MagickCore: display.c File Reference

# display.c File Reference

`#include "magick/studio.h"`
`#include "magick/blob.h"`
`#include "magick/client.h"`
`#include "magick/color.h"`
`#include "magick/colorspace.h"`
`#include "magick/composite.h"`
`#include "magick/constitute.h"`
`#include "magick/decorate.h"`
`#include "magick/delegate.h"`
`#include "magick/display.h"`
`#include "magick/display-private.h"`
`#include "magick/draw.h"`
`#include "magick/effect.h"`
`#include "magick/enhance.h"`
`#include "magick/exception.h"`
`#include "magick/exception-private.h"`
`#include "magick/fx.h"`
`#include "magick/geometry.h"`
`#include "magick/image-private.h"`
`#include "magick/list.h"`
`#include "magick/log.h"`
`#include "magick/magick.h"`
`#include "magick/memory_.h"`
`#include "magick/monitor.h"`
`#include "magick/montage.h"`
`#include "magick/option.h"`
`#include "magick/paint.h"`
`#include "magick/pixel.h"`
`#include "magick/pixel-private.h"`
`#include "magick/PreRvIcccm.h"`
`#include "magick/property.h"`
`#include "magick/quantum.h"`
`#include "magick/resize.h"`
`#include "magick/resource_.h"`
`#include "magick/shear.h"`
`#include "magick/segment.h"`
`#include "magick/string_.h"`
`#include "magick/transform.h"`
`#include "magick/threshold.h"`
`#include "magick/utility.h"`
`#include "magick/version.h"`
`#include "magick/widget.h"`
`#include "magick/xwindow-private.h"`

## Defines
#define | MaxColors MagickMin(windows->visual_info->colormap_size,256L)
#define | BricksWidth 20
#define | BricksHeight 20
#define | DiagonalWidth 16
#define | DiagonalHeight 16
#define | HighlightWidth 8
#define | HighlightHeight 8
#define | ScalesWidth 16
#define | ScalesHeight 16
#define | ShadowWidth 8
#define | ShadowHeight 8
#define | VerticalWidth 16
#define | VerticalHeight 16
#define | WavyWidth 16
#define | WavyHeight 16
#define | BackgroundImageTag "Background/Image"
#define | ApplyMenus 7
#define | TileImageTag "Scale/Image"
#define | XClientName "montage"
#define | MagnifySize 256
#define | MagickMenus 10
#define | MagickTitle "Commands"
## Enumerations
enum | ClipboardMode { CopyMode, CropMode, CutMode }
enum | CommandType { OpenCommand, SaveCommand, PlayCommand, StepCommand, RepeatCommand, AutoReverseCommand, SlowerCommand, FasterCommand, ForwardCommand, ReverseCommand, HelpCommand, BrowseDocumentationCommand, VersionCommand, InfoCommand, QuitCommand, StepBackwardCommand, StepForwardCommand, NullCommand, OpenCommand, NextCommand, FormerCommand, SelectCommand, SaveCommand, PrintCommand, DeleteCommand, NewCommand, VisualDirectoryCommand, QuitCommand, UndoCommand, RedoCommand, CutCommand, CopyCommand, PasteCommand, HalfSizeCommand, OriginalSizeCommand, DoubleSizeCommand, ResizeCommand, ApplyCommand, RefreshCommand, RestoreCommand, CropCommand, ChopCommand, FlopCommand, FlipCommand, RotateRightCommand, RotateLeftCommand, RotateCommand, ShearCommand, RollCommand, TrimCommand, HueCommand, SaturationCommand, BrightnessCommand, GammaCommand, SpiffCommand, DullCommand, ContrastStretchCommand, SigmoidalContrastCommand, NormalizeCommand, EqualizeCommand, NegateCommand, GrayscaleCommand, MapCommand, QuantizeCommand, DespeckleCommand, EmbossCommand, ReduceNoiseCommand, AddNoiseCommand, SharpenCommand, BlurCommand, ThresholdCommand, EdgeDetectCommand, SpreadCommand, ShadeCommand, RaiseCommand, SegmentCommand, SolarizeCommand, SepiaToneCommand, SwirlCommand, ImplodeCommand, VignetteCommand, WaveCommand, OilPaintCommand, CharcoalDrawCommand, AnnotateCommand, DrawCommand, ColorCommand, MatteCommand, CompositeCommand, AddBorderCommand, AddFrameCommand, CommentCommand, LaunchCommand, RegionofInterestCommand, ROIHelpCommand, ROIDismissCommand, InfoCommand, ZoomCommand, ShowPreviewCommand, ShowHistogramCommand, ShowMatteCommand, BackgroundCommand, SlideShowCommand, PreferencesCommand, HelpCommand, BrowseDocumentationCommand, VersionCommand, SaveToUndoBufferCommand, FreeBuffersCommand, NullCommand }
enum | ModeType { AnnotateNameCommand, AnnotateFontColorCommand, AnnotateBackgroundColorCommand, AnnotateRotateCommand, AnnotateHelpCommand, AnnotateDismissCommand, TextHelpCommand, TextApplyCommand, ChopDirectionCommand, ChopHelpCommand, ChopDismissCommand, HorizontalChopCommand, VerticalChopCommand, ColorEditMethodCommand, ColorEditColorCommand, ColorEditBorderCommand, ColorEditFuzzCommand, ColorEditUndoCommand, ColorEditHelpCommand, ColorEditDismissCommand, CompositeOperatorsCommand, CompositeDissolveCommand, CompositeDisplaceCommand, CompositeHelpCommand, CompositeDismissCommand, CropHelpCommand, CropDismissCommand, RectifyCopyCommand, RectifyHelpCommand, RectifyDismissCommand, DrawElementCommand, DrawColorCommand, DrawStippleCommand, DrawWidthCommand, DrawUndoCommand, DrawHelpCommand, DrawDismissCommand, MatteEditMethod, MatteEditBorderCommand, MatteEditFuzzCommand, MatteEditValueCommand, MatteEditUndoCommand, MatteEditHelpCommand, MatteEditDismissCommand, PasteOperatorsCommand, PasteHelpCommand, PasteDismissCommand, RotateColorCommand, RotateDirectionCommand, RotateCropCommand, RotateSharpenCommand, RotateHelpCommand, RotateDismissCommand, HorizontalRotateCommand, VerticalRotateCommand, TileLoadCommand, TileNextCommand, TileFormerCommand, TileDeleteCommand, TileUpdateCommand }
## Functions
static CommandType | XImageWindowCommand (Display *, XResourceInfo *, XWindows *, const MagickStatusType, KeySym, Image **)
static Image * | XMagickCommand (Display *, XResourceInfo *, XWindows *, const CommandType, Image **)
static Image ** | XOpenImage (Display *, XResourceInfo *, XWindows *, const MagickBooleanType)
static Image *** | XTileImage (Display *, XResourceInfo *, XWindows *, Image *, XEvent *)
static Image **** | XVisualDirectoryImage (Display *, XResourceInfo *, XWindows *)
static MagickBooleanType | XAnnotateEditImage (Display *, XResourceInfo *, XWindows *, Image *)
static MagickBooleanType | XDrawEditImage (Display *, XResourceInfo *, XWindows *, Image **)
static MagickBooleanType | XChopImage (Display *, XResourceInfo *, XWindows *, Image **)
static MagickBooleanType | XCropImage (Display *, XResourceInfo *, XWindows *, Image *, const ClipboardMode)
static MagickBooleanType | XBackgroundImage (Display *, XResourceInfo *, XWindows *, Image **)
static MagickBooleanType | XColorEditImage (Display *, XResourceInfo *, XWindows *, Image **)
static MagickBooleanType | XCompositeImage (Display *, XResourceInfo *, XWindows *, Image *)
static MagickBooleanType | XConfigureImage (Display *, XResourceInfo *, XWindows *, Image *)
static MagickBooleanType | XMatteEditImage (Display *, XResourceInfo *, XWindows *, Image **)
static MagickBooleanType | XPasteImage (Display *, XResourceInfo *, XWindows *, Image *)
static MagickBooleanType | XPrintImage (Display *, XResourceInfo *, XWindows *, Image *)
static MagickBooleanType | XRotateImage (Display *, XResourceInfo *, XWindows *, double, Image **)
static MagickBooleanType | XROIImage (Display *, XResourceInfo *, XWindows *, Image **)
static MagickBooleanType | XSaveImage (Display *, XResourceInfo *, XWindows *, Image *)
static MagickBooleanType | XTrimImage (Display *, XResourceInfo *, XWindows *, Image *)
static void | XDrawPanRectangle (Display *, XWindows *)
static void | XImageCache (Display *, XResourceInfo *, XWindows *, const CommandType, Image **)
static void | XMagnifyImage (Display *, XWindows *, XEvent *)
static void | XMakePanImage (Display *, XResourceInfo *, XWindows *, Image *)
static void | XPanImage (Display *, XWindows *, XEvent *)
static void | XMagnifyWindowCommand (Display *, XWindows *, const MagickStatusType, const KeySym)
static void | XSetCropGeometry (Display *, XWindows *, RectangleInfo *, Image *)
static void | XScreenEvent (Display *, XWindows *, XEvent *)
static void | XTranslateImage (Display *, XWindows *, Image *, const KeySym)
MagickExport MagickBooleanType | DisplayImages (const ImageInfo *image_info, Image *images)
MagickExport MagickBooleanType | RemoteDisplayCommand (const ImageInfo *image_info, const char *window, const char *filename, ExceptionInfo *exception)
static long | MagickMax (const long x, const long y)
static long | MagickMin (const long x, const long y)
static int | XPredicate (Display *magick_unused(display), XEvent *event, char *data)
MagickExport MagickBooleanType | XDisplayBackgroundImage (Display *display, XResourceInfo *resource_info, Image *image)
MagickExport Image * | XDisplayImage (Display *display, XResourceInfo *resource_info, char **argv, int argc, Image **image, unsigned long *state)
## Variables
static const unsigned char | HighlightBitmap [8]
static const unsigned char | ShadowBitmap [8]
static const char * | PageSizes []
static const char * | ImageAnnotateHelp []
static const char * | ImageChopHelp []
static const char * | ImageColorEditHelp []
static const char * | ImageCompositeHelp []
static const char * | ImageCutHelp []
static const char * | ImageCopyHelp []
static const char * | ImageCropHelp []
static const char * | ImageDrawHelp []
static const char * | DisplayHelp []
static const char * | ImageMatteEditHelp []
static const char * | ImagePanHelp []
static const char * | ImagePasteHelp []
static const char * | ImageROIHelp []
static const char * | ImageRotateHelp []
static const int | RoiDelta = 8
static const unsigned char | BricksBitmap []
static const unsigned char | DiagonalBitmap []
static const unsigned char | ScalesBitmap []
static const unsigned char | VerticalBitmap []
static const unsigned char | WavyBitmap []

## Define Documentation

#define ApplyMenus 7

#define BackgroundImageTag "Background/Image"

#define BricksHeight 20

#define BricksWidth 20

#define DiagonalHeight 16

#define DiagonalWidth 16

#define HighlightHeight 8

#define HighlightWidth 8

#define MagickMenus 10

#define MagickTitle "Commands"

#define MagnifySize 256

#define MaxColors MagickMin(windows->visual_info->colormap_size,256L)

#define ScalesHeight 16

#define ScalesWidth 16

#define ShadowHeight 8

#define ShadowWidth 8

#define TileImageTag "Scale/Image"

#define VerticalHeight 16

#define VerticalWidth 16

#define WavyHeight 16

#define WavyWidth 16

#define XClientName "montage"

## Enumeration Type Documentation

enum ClipboardMode

Enumerator:

  CopyMode |
  CropMode |
  CutMode |

enum CommandType

Enumerator:

  OpenCommand |
  SaveCommand |
  PlayCommand |
  StepCommand |
  RepeatCommand |
  AutoReverseCommand |
  SlowerCommand |
  FasterCommand |
  ForwardCommand |
  ReverseCommand |
  HelpCommand |
  BrowseDocumentationCommand |
  VersionCommand |
  InfoCommand |
  QuitCommand |
  StepBackwardCommand |
  StepForwardCommand |
  NullCommand |
  OpenCommand |
  NextCommand |
  FormerCommand |
  SelectCommand |
  SaveCommand |
  PrintCommand |
  DeleteCommand |
  NewCommand |
  VisualDirectoryCommand |
  QuitCommand |
  UndoCommand |
  RedoCommand |
  CutCommand |
  CopyCommand |
  PasteCommand |
  HalfSizeCommand |
  OriginalSizeCommand |
  DoubleSizeCommand |
  ResizeCommand |
  ApplyCommand |
  RefreshCommand |
  RestoreCommand |
  CropCommand |
  ChopCommand |
  FlopCommand |
  FlipCommand |
  RotateRightCommand |
  RotateLeftCommand |
  RotateCommand |
  ShearCommand |
  RollCommand |
  TrimCommand |
  HueCommand |
  SaturationCommand |
  BrightnessCommand |
  GammaCommand |
  SpiffCommand |
  DullCommand |
  ContrastStretchCommand |
  SigmoidalContrastCommand |
  NormalizeCommand |
  EqualizeCommand |
  NegateCommand |
  GrayscaleCommand |
  MapCommand |
  QuantizeCommand |
  DespeckleCommand |
  EmbossCommand |
  ReduceNoiseCommand |
  AddNoiseCommand |
  SharpenCommand |
  BlurCommand |
  ThresholdCommand |
  EdgeDetectCommand |
  SpreadCommand |
  ShadeCommand |
  RaiseCommand |
  SegmentCommand |
  SolarizeCommand |
  SepiaToneCommand |
  SwirlCommand |
  ImplodeCommand |
  VignetteCommand |
  WaveCommand |
  OilPaintCommand |
  CharcoalDrawCommand |
  AnnotateCommand |
  DrawCommand |
  ColorCommand |
  MatteCommand |
  CompositeCommand |
  AddBorderCommand |
  AddFrameCommand |
  CommentCommand |
  LaunchCommand |
  RegionofInterestCommand |
  ROIHelpCommand |
  ROIDismissCommand |
  InfoCommand |
  ZoomCommand |
  ShowPreviewCommand |
  ShowHistogramCommand |
  ShowMatteCommand |
  BackgroundCommand |
  SlideShowCommand |
  PreferencesCommand |
  HelpCommand |
  BrowseDocumentationCommand |
  VersionCommand |
  SaveToUndoBufferCommand |
  FreeBuffersCommand |
  NullCommand |

enum ModeType

Enumerator:

  AnnotateNameCommand |
  AnnotateFontColorCommand |
  AnnotateBackgroundColorCommand |
  AnnotateRotateCommand |
  AnnotateHelpCommand |
  AnnotateDismissCommand |
  TextHelpCommand |
  TextApplyCommand |
  ChopDirectionCommand |
  ChopHelpCommand |
  ChopDismissCommand |
  HorizontalChopCommand |
  VerticalChopCommand |
  ColorEditMethodCommand |
  ColorEditColorCommand |
  ColorEditBorderCommand |
  ColorEditFuzzCommand |
  ColorEditUndoCommand |
  ColorEditHelpCommand |
  ColorEditDismissCommand |
  CompositeOperatorsCommand |
  CompositeDissolveCommand |
  CompositeDisplaceCommand |
  CompositeHelpCommand |
  CompositeDismissCommand |
  CropHelpCommand |
  CropDismissCommand |
  RectifyCopyCommand |
  RectifyHelpCommand |
  RectifyDismissCommand |
  DrawElementCommand |
  DrawColorCommand |
  DrawStippleCommand |
  DrawWidthCommand |
  DrawUndoCommand |
  DrawHelpCommand |
  DrawDismissCommand |
  MatteEditMethod |
  MatteEditBorderCommand |
  MatteEditFuzzCommand |
  MatteEditValueCommand |
  MatteEditUndoCommand |
  MatteEditHelpCommand |
  MatteEditDismissCommand |
  PasteOperatorsCommand |
  PasteHelpCommand |
  PasteDismissCommand |
  RotateColorCommand |
  RotateDirectionCommand |
  RotateCropCommand |
  RotateSharpenCommand |
  RotateHelpCommand |
  RotateDismissCommand |
  HorizontalRotateCommand |
  VerticalRotateCommand |
  TileLoadCommand |
  TileNextCommand |
  TileFormerCommand |
  TileDeleteCommand |
  TileUpdateCommand |

## Function Documentation

MagickExport MagickBooleanType DisplayImages | ( | const ImageInfo * | image_info,
|  | Image * | images |
| ) |  |  |

static long MagickMax | ( | const long | x,
|  | const long | y |
| ) |  |  | `[inline, static]`

static long MagickMin | ( | const long | x,
|  | const long | y |
| ) |  |  | `[inline, static]`

MagickExport MagickBooleanType RemoteDisplayCommand | ( | const ImageInfo * | image_info,
|  | const char * | window,
|  | const char * | filename,
|  | ExceptionInfo * | exception |
| ) |  |  |

static MagickBooleanType XAnnotateEditImage | ( | Display * | display,
|  | XResourceInfo * | resource_info,
|  | XWindows * | windows,
|  | Image * | image |
| ) |  |  | `[static]`

static MagickBooleanType XBackgroundImage | ( | Display * | display,
|  | XResourceInfo * | resource_info,
|  | XWindows * | windows,
|  | Image ** | image |
| ) |  |  |

static MagickBooleanType XChopImage | ( | Display * | display,
|  | XResourceInfo * | resource_info,
|  | XWindows * | windows,
|  | Image ** | image |
| ) |  |  |

static MagickBooleanType XColorEditImage | ( | Display * | display,
|  | XResourceInfo * | resource_info,
|  | XWindows * | windows,
|  | Image ** | image |
| ) |  |  |

static MagickBooleanType XCompositeImage | ( | Display * | display,
|  | XResourceInfo * | resource_info,
|  | XWindows * | windows,
|  | Image * | image |
| ) |  |  |

static MagickBooleanType XConfigureImage | ( | Display * | display,
|  | XResourceInfo * | resource_info,
|  | XWindows * | windows,
|  | Image * | image |
| ) |  |  |

static MagickBooleanType XCropImage | ( | Display * | display,
|  | XResourceInfo * | resource_info,
|  | XWindows * | windows,
|  | Image * | image,
|  | const | ClipboardMode |
| ) |  |  |

MagickExport MagickBooleanType XDisplayBackgroundImage | ( | Display * | display,
|  | XResourceInfo * | resource_info,
|  | Image * | image |
| ) |  |  |

MagickExport Image* XDisplayImage | ( | Display * | display,
|  | XResourceInfo * | resource_info,
|  | char ** | argv,
|  | int | argc,
|  | Image ** | image,
|  | unsigned long * | state |
| ) |  |  |

static MagickBooleanType XDrawEditImage | ( | Display * | display,
|  | XResourceInfo * | resource_info,
|  | XWindows * | windows,
|  | Image ** | image |
| ) |  |  |

static void XDrawPanRectangle | ( | Display * | display,
|  | XWindows * | windows |
| ) |  |  | `[static]`

static void XImageCache | ( | Display * | display,
|  | XResourceInfo * | resource_info,
|  | XWindows * | windows,
|  | const | CommandType,
|  | Image ** | image |
| ) |  |  |

static CommandType XImageWindowCommand | ( | Display * | display,
|  | XResourceInfo * | resource_info,
|  | XWindows * | windows,
|  | const | MagickStatusType,
|  | KeySym | key_symbol,
|  | Image ** | image |
| ) |  |  | `[static]`

static Image * XMagickCommand | ( | Display * | display,
|  | XResourceInfo * | resource_info,
|  | XWindows * | windows,
|  | const | CommandType,
|  | Image ** | image |
| ) |  |  | `[static]`

static void XMagnifyImage | ( | Display * | display,
|  | XWindows * | windows,
|  | XEvent * | event |
| ) |  |  |

static void XMagnifyWindowCommand | ( | Display * | display,
|  | XWindows * | windows,
|  | const | MagickStatusType,
|  | const | KeySym |
| ) |  |  |

static void XMakePanImage | ( | Display * | display,
|  | XResourceInfo * | resource_info,
|  | XWindows * | windows,
|  | Image * | image |
| ) |  |  |

static MagickBooleanType XMatteEditImage | ( | Display * | display,
|  | XResourceInfo * | resource_info,
|  | XWindows * | windows,
|  | Image ** | image |
| ) |  |  |

static Image * XOpenImage | ( | Display * | display,
|  | XResourceInfo * | resource_info,
|  | XWindows * | windows,
|  | const | MagickBooleanType |
| ) |  |  |

static void XPanImage | ( | Display * | display,
|  | XWindows * | windows,
|  | XEvent * | event |
| ) |  |  |

static MagickBooleanType XPasteImage | ( | Display * | display,
|  | XResourceInfo * | resource_info,
|  | XWindows * | windows,
|  | Image * | image |
| ) |  |  |

static int XPredicate | ( | Display * | magick_unused(display),
|  | XEvent * | event,
|  | char * | data |
| ) |  |  | `[static]`

static MagickBooleanType XPrintImage | ( | Display * | display,
|  | XResourceInfo * | resource_info,
|  | XWindows * | windows,
|  | Image * | image |
| ) |  |  |

static MagickBooleanType XROIImage | ( | Display * | display,
|  | XResourceInfo * | resource_info,
|  | XWindows * | windows,
|  | Image ** | image |
| ) |  |  |

static MagickBooleanType XRotateImage | ( | Display * | display,
|  | XResourceInfo * | resource_info,
|  | XWindows * | windows,
|  | double | degrees,
|  | Image ** | image |
| ) |  |  |

static MagickBooleanType XSaveImage | ( | Display * | display,
|  | XResourceInfo * | resource_info,
|  | XWindows * | windows,
|  | Image * | image |
| ) |  |  |

static void XScreenEvent | ( | Display * | display,
|  | XWindows * | windows,
|  | XEvent * | event |
| ) |  |  |

static void XSetCropGeometry | ( | Display * | display,
|  | XWindows * | windows,
|  | RectangleInfo * | crop_info,
|  | Image * | image |
| ) |  |  |

static Image * XTileImage | ( | Display * | display,
|  | XResourceInfo * | resource_info,
|  | XWindows * | windows,
|  | Image * | image,
|  | XEvent * | event |
| ) |  |  |

static void XTranslateImage | ( | Display * | display,
|  | XWindows * | windows,
|  | Image * | image,
|  | const | KeySym |
| ) |  |  |

static MagickBooleanType XTrimImage | ( | Display * | display,
|  | XResourceInfo * | resource_info,
|  | XWindows * | windows,
|  | Image * | image |
| ) |  |  |

static Image * XVisualDirectoryImage | ( | Display * | display,
|  | XResourceInfo * | resource_info,
|  | XWindows * | windows |
| ) |  |  |

## Variable Documentation

const unsigned char BricksBitmap[]`[static]`

Initial value:

      {
        0xff, 0xff, 0x0f, 0x03, 0x0c, 0x00, 0x03, 0x0c, 0x00, 0x03, 0x0c, 0x00,
        0x03, 0x0c, 0x00, 0xff, 0xff, 0x0f, 0x60, 0x80, 0x01, 0x60, 0x80, 0x01,
        0x60, 0x80, 0x01, 0x60, 0x80, 0x01, 0xff, 0xff, 0x0f, 0x03, 0x0c, 0x00,
        0x03, 0x0c, 0x00, 0x03, 0x0c, 0x00, 0x03, 0x0c, 0x00, 0xff, 0xff, 0x0f,
        0x60, 0x80, 0x01, 0x60, 0x80, 0x01, 0x60, 0x80, 0x01, 0x60, 0x80, 0x01
      }

const unsigned char DiagonalBitmap[]`[static]`

Initial value:

      {
        0x44, 0x44, 0x88, 0x88, 0x11, 0x11, 0x22, 0x22, 0x44, 0x44, 0x88, 0x88,
        0x11, 0x11, 0x22, 0x22, 0x44, 0x44, 0x88, 0x88, 0x11, 0x11, 0x22, 0x22,
        0x44, 0x44, 0x88, 0x88, 0x11, 0x11, 0x22, 0x22
      }

const char * DisplayHelp[]`[static]`

const unsigned char HighlightBitmap[8]`[static]`

Initial value:

      {
        0xaa, 0x55, 0xaa, 0x55, 0xaa, 0x55, 0xaa, 0x55
      }

const char* ImageAnnotateHelp[]`[static]`

const char * ImageChopHelp[]`[static]`

Initial value:

      {
        "In chop mode, the Command widget has these options:",
        "",
        "    Direction",
        "      horizontal",
        "      vertical",
        "    Help",
        "    Dismiss",
        "",
        "If the you choose the horizontal direction (this is the",
        "default), the area of the image between the two horizontal",
        "endpoints of the chop line is removed.  Otherwise, the area",
        "of the image between the two vertical endpoints of the chop",
        "line is removed.",
        "",
        "Select a location within the image window to begin your chop,",
        "press and hold any button.  Next, move the pointer to",
        "another location in the image.  As you move a line will",
        "connect the initial location and the pointer.  When you",
        "release the button, the area within the image to chop is",
        "determined by which direction you choose from the Command",
        "widget.",
        "",
        "To cancel the image chopping, move the pointer back to the",
        "starting point of the line and release the button.",
        (char *) NULL,
      }

const char * ImageColorEditHelp[]`[static]`

const char * ImageCompositeHelp[]`[static]`

const char * ImageCopyHelp[]`[static]`

Initial value:

      {
        "In copy mode, the Command widget has these options:",
        "",
        "    Help",
        "    Dismiss",
        "",
        "To define a copy region, press button 1 and drag.  The",
        "copy region is defined by a highlighted rectangle that",
        "expands or contracts as it follows the pointer.  Once you",
        "are satisfied with the copy region, release the button.",
        "You are now in rectify mode.  In rectify mode, the Command",
        "widget has these options:",
        "",
        "    Copy",
        "    Help",
        "    Dismiss",
        "",
        "You can make adjustments by moving the pointer to one of the",
        "copy rectangle corners, pressing a button, and dragging.",
        "Finally, press Copy to commit your copy region.  To",
        "exit without copying the image, press Dismiss.",
        (char *) NULL,
      }

const char * ImageCropHelp[]`[static]`

Initial value:

      {
        "In crop mode, the Command widget has these options:",
        "",
        "    Help",
        "    Dismiss",
        "",
        "To define a cropping region, press button 1 and drag.  The",
        "cropping region is defined by a highlighted rectangle that",
        "expands or contracts as it follows the pointer.  Once you",
        "are satisfied with the cropping region, release the button.",
        "You are now in rectify mode.  In rectify mode, the Command",
        "widget has these options:",
        "",
        "    Crop",
        "    Help",
        "    Dismiss",
        "",
        "You can make adjustments by moving the pointer to one of the",
        "cropping rectangle corners, pressing a button, and dragging.",
        "Finally, press Crop to commit your cropping region.  To",
        "exit without cropping the image, press Dismiss.",
        (char *) NULL,
      }

const char * ImageCutHelp[]`[static]`

Initial value:

      {
        "In cut mode, the Command widget has these options:",
        "",
        "    Help",
        "    Dismiss",
        "",
        "To define a cut region, press button 1 and drag.  The",
        "cut region is defined by a highlighted rectangle that",
        "expands or contracts as it follows the pointer.  Once you",
        "are satisfied with the cut region, release the button.",
        "You are now in rectify mode.  In rectify mode, the Command",
        "widget has these options:",
        "",
        "    Cut",
        "    Help",
        "    Dismiss",
        "",
        "You can make adjustments by moving the pointer to one of the",
        "cut rectangle corners, pressing a button, and dragging.",
        "Finally, press Cut to commit your copy region.  To",
        "exit without cutting the image, press Dismiss.",
        (char *) NULL,
      }

const char * ImageDrawHelp[]`[static]`

const char * ImageMatteEditHelp[]`[static]`

const char * ImagePanHelp[]`[static]`

Initial value:

      {
        "When an image exceeds the width or height of the X server",
        "screen, display maps a small panning icon.  The rectangle",
        "within the panning icon shows the area that is currently",
        "displayed in the image window.  To pan about the image,",
        "press any button and drag the pointer within the panning",
        "icon.  The pan rectangle moves with the pointer and the",
        "image window is updated to reflect the location of the",
        "rectangle within the panning icon.  When you have selected",
        "the area of the image you wish to view, release the button.",
        "",
        "Use the arrow keys to pan the image one pixel up, down,",
        "left, or right within the image window.",
        "",
        "The panning icon is withdrawn if the image becomes smaller",
        "than the dimensions of the X server screen.",
        (char *) NULL,
      }

const char * ImagePasteHelp[]`[static]`

const char * ImageROIHelp[]`[static]`

const char * ImageRotateHelp[]`[static]`

const char* PageSizes[]`[static]`

Initial value:

      {
        "Letter",
        "Tabloid",
        "Ledger",
        "Legal",
        "Statement",
        "Executive",
        "A3",
        "A4",
        "A5",
        "B4",
        "B5",
        "Folio",
        "Quarto",
        "10x14",
        (char *) NULL
      }

const int RoiDelta = 8`[static]`

const unsigned char ScalesBitmap[]`[static]`

Initial value:

      {
        0x08, 0x08, 0x08, 0x08, 0x14, 0x14, 0xe3, 0xe3, 0x80, 0x80, 0x80, 0x80,
        0x41, 0x41, 0x3e, 0x3e, 0x08, 0x08, 0x08, 0x08, 0x14, 0x14, 0xe3, 0xe3,
        0x80, 0x80, 0x80, 0x80, 0x41, 0x41, 0x3e, 0x3e
      }

const unsigned char ShadowBitmap[8]`[static]`

Initial value:

      {
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
      }

const unsigned char VerticalBitmap[]`[static]`

Initial value:

      {
        0x11, 0x11, 0x11, 0x11, 0x11, 0x11, 0x11, 0x11, 0x11, 0x11, 0x11, 0x11,
        0x11, 0x11, 0x11, 0x11, 0x11, 0x11, 0x11, 0x11, 0x11, 0x11, 0x11, 0x11,
        0x11, 0x11, 0x11, 0x11, 0x11, 0x11, 0x11, 0x11
      }

const unsigned char WavyBitmap[]`[static]`

Initial value:

      {
        0xfe, 0xff, 0xfe, 0xff, 0xfe, 0xff, 0xfd, 0xff, 0xfd, 0xff, 0xfb, 0xff,
        0xe7, 0xff, 0x1f, 0xff, 0xff, 0xf8, 0xff, 0xe7, 0xff, 0xdf, 0xff, 0xbf,
        0xff, 0xbf, 0xff, 0x7f, 0xff, 0x7f, 0xff, 0x7f
      }